Show / Hide Table of Contents

# Class ImGuizmo

##### Inheritance

System.Object
ImGuizmo

##### Inherited Members

System.Object.ToString()
System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.ReferenceEquals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()

###### Namespace: ImGuizmoNET

###### Assembly: ImGui.NET.dll

##### Syntax

    public static class ImGuizmo

### Methods

| Improve this Doc View Source

#### AllowAxisFlip(Boolean)

##### Declaration

    public static void AllowAxisFlip(bool value)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | value |

| Improve this Doc View Source

#### BeginFrame()

##### Declaration

    public static void BeginFrame()

| Improve this Doc View Source

#### DecomposeMatrixToComponents(ref Single, ref Single, ref Single, ref Single)

##### Declaration

    public static void DecomposeMatrixToComponents(ref float matrix, ref float translation, ref float rotation, ref float scale)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | matrix |
System.Single | translation |
System.Single | rotation |
System.Single | scale |

| Improve this Doc View Source

#### DrawCubes(ref Single, ref Single, ref Single, Int32)

##### Declaration

    public static void DrawCubes(ref float view, ref float projection, ref float matrices, int matrixCount)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
System.Single | matrices |
System.Int32 | matrixCount |

| Improve this Doc View Source

#### DrawGrid(ref Single, ref Single, ref Single, Single)

##### Declaration

    public static void DrawGrid(ref float view, ref float projection, ref float matrix, float gridSize)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
System.Single | matrix |
System.Single | gridSize |

| Improve this Doc View Source

#### Enable(Boolean)

##### Declaration

    public static void Enable(bool enable)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | enable |

| Improve this Doc View Source

#### IsOver()

##### Declaration

    public static bool IsOver()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsOver(OPERATION)

##### Declaration

    public static bool IsOver(OPERATION op)

##### Parameters

Type | Name | Description
--- | --- | ---
OPERATION | op |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsUsing()

##### Declaration

    public static bool IsUsing()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Manipulate(ref Single, ref Single, OPERATION, MODE, ref Single)

##### Declaration

    public static bool Manipulate(ref float view, ref float projection, OPERATION operation, MODE mode, ref float matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
OPERATION | operation |
MODE | mode |
System.Single | matrix |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Manipulate(ref Single, ref Single, OPERATION, MODE, ref Single, ref Single)

##### Declaration

    public static bool Manipulate(ref float view, ref float projection, OPERATION operation, MODE mode, ref float matrix, ref float deltaMatrix)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
OPERATION | operation |
MODE | mode |
System.Single | matrix |
System.Single | deltaMatrix |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Manipulate(ref Single, ref Single, OPERATION, MODE, ref Single, ref Single, ref Single)

##### Declaration

    public static bool Manipulate(ref float view, ref float projection, OPERATION operation, MODE mode, ref float matrix, ref float deltaMatrix, ref float snap)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
OPERATION | operation |
MODE | mode |
System.Single | matrix |
System.Single | deltaMatrix |
System.Single | snap |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Manipulate(ref Single, ref Single, OPERATION, MODE, ref Single, ref Single, ref Single, ref Single)

##### Declaration

    public static bool Manipulate(ref float view, ref float projection, OPERATION operation, MODE mode, ref float matrix, ref float deltaMatrix, ref float snap, ref float localBounds)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
OPERATION | operation |
MODE | mode |
System.Single | matrix |
System.Single | deltaMatrix |
System.Single | snap |
System.Single | localBounds |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Manipulate(ref Single, ref Single, OPERATION, MODE, ref Single, ref Single, ref Single, ref Single, ref Single)

##### Declaration

    public static bool Manipulate(ref float view, ref float projection, OPERATION operation, MODE mode, ref float matrix, ref float deltaMatrix, ref float snap, ref float localBounds, ref float boundsSnap)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | projection |
OPERATION | operation |
MODE | mode |
System.Single | matrix |
System.Single | deltaMatrix |
System.Single | snap |
System.Single | localBounds |
System.Single | boundsSnap |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### RecomposeMatrixFromComponents(ref Single, ref Single, ref Single, ref Single)

##### Declaration

    public static void RecomposeMatrixFromComponents(ref float translation, ref float rotation, ref float scale, ref float matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | translation |
System.Single | rotation |
System.Single | scale |
System.Single | matrix |

| Improve this Doc View Source

#### SetDrawlist()

##### Declaration

    public static void SetDrawlist()

| Improve this Doc View Source

#### SetDrawlist(ImDrawListPtr)

##### Declaration

    public static void SetDrawlist(ImDrawListPtr drawlist)

##### Parameters

Type | Name | Description
--- | --- | ---
ImDrawListPtr | drawlist |

| Improve this Doc View Source

#### SetGizmoSizeClipSpace(Single)

##### Declaration

    public static void SetGizmoSizeClipSpace(float value)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | value |

| Improve this Doc View Source

#### SetID(Int32)

##### Declaration

    public static void SetID(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

| Improve this Doc View Source

#### SetImGuiContext(IntPtr)

##### Declaration

    public static void SetImGuiContext(IntPtr ctx)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | ctx |

| Improve this Doc View Source

#### SetOrthographic(Boolean)

##### Declaration

    public static void SetOrthographic(bool isOrthographic)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | isOrthographic |

| Improve this Doc View Source

#### SetRect(Single, Single, Single, Single)

##### Declaration

    public static void SetRect(float x, float y, float width, float height)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | x |
System.Single | y |
System.Single | width |
System.Single | height |

| Improve this Doc View Source

#### ViewManipulate(ref Single, Single, Vector2, Vector2, UInt32)

##### Declaration

    public static void ViewManipulate(ref float view, float length, Vector2 position, Vector2 size, uint backgroundColor)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | view |
System.Single | length |
System.Numerics.Vector2 | position |
System.Numerics.Vector2 | size |
System.UInt32 | backgroundColor |